
2.12  2021-03-11
  - Mojolicious::Plugin::AssetPack is now maintained by the Mojolicious team.

2.11 2021-02-19T10:23:04+0900
 - Use 'partial(1)->to' instead of 'detour' which was deprecated in Mojolicious 9.0
   Contributor: Marius Kittler

2.10 2020-12-11T11:16:01+0900
 - Fixes warnings issued by latest Mojolicious
   Contributor: Zoffix Znet

2.09 2020-09-07T08:56:50+0900
 - Prevent JavaScript from runnning in 404 assets #140
 - Slimmed down the bundled documentation

2.08 2019-05-07T21:16:40+0700
 - Fix link to Mojolicious::Plugin::Webpack

2.07 2019-05-04T23:54:32+0700
  - Add RollupJs->add_global();
  - Add note about Mojolicious::Plugin::Webpack

2.06 2018-09-02T22:25:13+0200
 - Fix deprecated coffee-script@1.12.7: CoffeeScript on NPM has moved to coffeescript
 - Fix RollupJs pipe compatible with new rollupjs #138

2.05 2018-08-01T14:19:35+0800
 - Fix s///r is not supported in older Perls #136
 - Fix Favicon rendering of manifest and browserconfig
 - Add Asset::renderer() for dynamic assets
 - Add fallback for serving assets with wrong checksum
 - Renamed Asset::renderer() to tag_for()

2.04 2018-07-19T17:39:06+0800
 - Add support for generating manifest with Favicon pipe
 - Marked AssetPack::tag_for() as deprecated
 - Removed support for Mojolicious::Plugin::AssetPack::Backcompat

2.03 2018-04-26T10:22:06+0200
 - Ensure asset is processed when calling processed
 - Update favicon generator URL to use https
 - Set higher inactivity timeout for favicon generator

2.02 2018-01-28T13:12:59+0100
 - Add EXPERIMENTAL support for fetching assets from helpers

2.01 2017-11-06T13:02:45+0100
 - Up version number to try to fix pause indexing issues
 - NOTE: 2.00 was a mistake. There are no major changes

2.00 2017-10-29T10:08:37+0800
 - Fix RollupJs package name #130
 - load_module() confess on error
 - Removed EXPERIMENTAL Reloader pipe
 - Removed EXPERIMENTAL clone() method in AssetPack::Asset

1.47 2017-10-14T18:58:55+0200
 - Dropping "original" from assetpack.db

1.46 2017-09-27T21:35:33+0200
 - Add "asset_class" attribute to AssetPack::Store
 - Add rollupjs pipe - https://rollupjs.org/

1.45 2017-06-19T23:49:30+0200
 - Add Developing guide
 - Removed deprecated method end_range() from AssetPack::Asset
 - Removed deprecated method get_chunk() from AssetPack::Asset
 - Removed deprecated method is_range() from AssetPack::Asset
 - Removed deprecated method mtime() from AssetPack::Asset
 - Removed deprecated method start_range() from AssetPack::Asset
 - Removed deprecated method tag_helper() from AssetPack::Asset
 - Removed MOJO_ASSETPACK_CLEANUP (only used in test suite)
 - Can prevent AssetPack::Store from writing assetpack.db while developing
   with MOJO_ASSETPACK_LAZY=1 (EXPERIMENTAL)

1.44 2017-05-21T23:02:46+0200
 - Improved documentation #125
   Contributor: William Lindley

1.43 2017-05-12T14:38:02+0200
 - Fix not escaping Vuejs template code
 - Less verbose logging when processing assets

1.42 2017-04-29T14:23:37+0200
 - Fix missing use lib '.' in register.t #124
 - Add fetching of source maps to "Fetch" pipe #117

1.41 2017-03-15T22:09:14+0100
 - Fix bug in @import regex used by Pipe::Sass

1.40 2017-02-05T15:10:58-0800
 - Fix skipping @import in comments #121
 - Improved documentation for assetpack.def and paths #110
 - Can disable Pipe::Reloader from the browser

1.39 2017-01-25T22:39:45+0100
 - Skipping t/sass-source-map.t for now #115
   http://cpantesters.org/cpan/report/c59d94d4-e16e-11e6-ab5a-96809f28caea

1.38 2017-01-23T14:12:31+0100
 - Fix missing path() function in Pipe::Sass

1.37 2017-01-12T20:52:18+0100
 - Add support for sass source maps
 - No need to delete known media types in AssetPack::Store

1.36 2017-01-11T11:18:45+0100
 - Fix bug in Fetch pipe, fixing t/font-awesome.t
 - Change Mojolicious::Plugin::AssetPack::Asset::path() to return a Mojo::File object

1.35 2017-01-11T10:30:09+0100
 - Forgot to remove Carp::Always from t/recreate.t after debugging

1.34 2017-01-10T23:22:16+0100
 - Compatible with Mojolicious 7.15

1.33 2017-01-08T14:20:03+0100
 - Fix t/reloader.t when CSS::Minifier::XS is missing #113

1.32 2017-01-08T11:50:36+0100
 - Fix Mojo::Home::rel_dir is DEPRECATED in favor of Mojo::Hom::rel_file #112
 - Disable "Reloader" pipe, unless in development

1.31 2017-01-04T14:19:34+0100
 - Fix generating favicons once with MOJO_ASSETPACK_LAZY
 - Made Reloader call process() later

1.30 2016-12-23T03:14:34+0100
 - Fix CoffeeScript, by changing to coffee-script npm package
 - Fix "Unable to download" messages after downloaded sass file #107
 - Add EXPERIMENTAL support for MOJO_ASSETPACK_LAZY=1
 - Marked AssetPack::Asset::mtime() as deprecated

1.29 2016-12-15T23:04:40+0100
 - Fix custom helper name #111

1.28 2016-11-24T10:51:55+0100
 - Fix resetting end_range and start_range after a "Range: bytes=..." request #109

1.27 2016-11-18T15:13:55+0100
 - Add custom 404 page when an asset could not be found

1.26 2016-11-13T17:50:42+0100
 - Change Pipe::Fetch to avoid fetching URL that start with "#" #108

1.25 2016-10-30T21:24:48+0100
 - Add end_range(), start_range() and is_range() to Asset #104

1.24 2016-09-11T17:22:08+0200
 - Forgot to delete t/sass-current-app.t after 1.23

1.23 2016-09-11T17:01:57+0200
 - Add EXPERIMENTAL support for mixing in dynamic SASS files

1.22 2016-09-02T14:27:42+0200
 - Fix showing error message when asset could not be found

1.21 2016-08-29T15:48:01+0200
 - Add support for merging assetpack.db files

1.20 2016-08-19T15:11:58+0200
 - Add EXPERIMENTAL Mojolicious::Plugin::AssetPack::Pipe::TypeScript
 - Will default to "==" test when checking mode in assetpack.def
 - Moved Backcompat to the Mojolicious-Plugin-AssetPack-Backcompat dist

1.19 2016-08-10T19:14:16+0200
 - Add EXPERIMENTAL support for compiling .vue (Vue.js) files

1.18 2016-07-25T17:52:06+0200
 - Fix Can't locate object method "authority" via package "Mojo::URL" #102

1.17 2016-07-18T18:43:23+0200
 - Removed Mojolicious::Plugin::AssetPack::Asset::tag_helper()
 - Add Mojolicious::Plugin::AssetPack::tag_for()
 - Add Mojolicious::Plugin::AssetPack::Asset::url_for()
 - Add EXPERIMENTAL Mojolicious::Plugin::AssetPack::Pipe::Favicon
 - Add support for gif, ico, mp3, mp4, ogg, ogv, svg and webm.

1.16 2016-06-29T19:05:43+0200
 - Improved documentation for store() #101

1.15 2016-06-23T10:50:26+0200
 - Fix Fetch pipe will skip downloading "data:..." urls #100

1.14 2016-06-21T13:33:41+0200
 - Fix Fetch::URL_RE for url(...) without quotes #91 #99
 - Fix trimming whitespace for topics in .def file, closes #93
 - Fix replacing all fetched files #94
 - Will show download error message #96

1.13 2016-05-21T08:11:27+0200
 - Fix sass-current-app.t after 1.12

1.12 2016-05-20T20:59:10+0200
 - Fix compressing Sass assets with SASS_STYLE_COMPRESSED
   Contributor: Zoffix Znet

1.11 2016-05-17T07:55:56+0200
 - Fix failing reloader-process.t

1.10 2016-05-15T11:50:24+0200
 - Fix watching the actual input asset files in Pipe::Reloader #86
   Contributor: Mark Grimes

1.09 2016-05-10T21:36:09+0200
 - Fix to deal with multiple imports of the same Sass file #83
   Contributor: Mark Grimes

1.08 2016-05-09T22:23:42+0200
 - Add support for minifying jpeg image files
 - Add support for minifying png image files #81
   Contributor: Heiko Jansen
 - Add Mojolicious::Plugin::AssetPack::Asset::tag_helper() to support
   future "image" assets.

1.07 2016-05-03T13:55:45+0200
 - Fix rendering assets URL in mounted apps

1.06 2016-04-17T14:22:08+0200
 - Fix Fetch with Combine #75

1.05 2016-04-17T11:19:29+0200
 - Need to "use CSS::Sass 3.3.0" to avoid test failures on missing features
 - Add support for automatic download of fonts #75
 - Add support for conditions in assetpack.def #78
 - Fix SCSS files with UTF-8 encoding #70
 - Fix adding route earlier than on the first request #77
 - Fix setting url() on asset from db file

1.04 2016-04-08T22:40:29+0200
 - Fix Pipe::Reloader and files from def file
 - Change default Pipe::Reloader strategy to "document" to make reloading
   JavaScript more robust.

1.03 2016-04-08T20:15:31+0200
 - Add Pipe::Reloader for instant refresh in browser on asset change #72
 - Marked old modules as deprecated

1.02 2016-04-08T14:30:19+0200
 - Add support for "sass_functions" #68
   Contributor: Mark Grimes
 - Fix 2 naked subroutines
 - Fix t/sass.t: #919191 != #909090
 - Skip more old tests by default

1.01 2016-04-06T16:10:06+0200
 - Cannot load CSS::Minifier::XS in old code - The module is optional
 - Cannot load JavaScript::Minifier::XS in old code - The module is optional

1.00 2016-04-02T21:26:35+0200
 - Rewrote the module. Breaking changes might occur.
 - Changed from "pre-processors" to "pipes"

0.69 2015-12-02T16:37:36+0100
 - Fix "uninitialized value" warning in Scss.pm line 203 #65
 - Fix fetch() from $app

0.68 2015-09-28T08:28:29+0200
 - Will skip tests unless possible to write to out_dir

0.67 2015-09-27T15:24:23+0200
 - Fix asset can be read-only

0.66 2015-09-27T14:56:56+0200
 - Skip some tests on windows
 - Remove EXPERIMENTAL remark for wildcards in filenames #52
 - Remove EXPERIMENTAL remark from headers()
 - Remove EXPERIMENTAL remark from source_paths()

0.65 2015-09-25T16:55:49+0200
 - Add EXPERIMENTAL fixed mapping between moniker to packed files #64
 - Add EXPERIMENTAL test_app() to ensure all assets are created
 - Change headers() into a method
 - Change out_dir() into a read-only method, as documented
 - Remove EXPERIMENTAL support for reloader.js
 - Remove deprecated preprocessor() method
 - Remove support for in-memory assets #64
 - Fix memory leak

0.64 2015-09-20T11:44:26+0200
 - Add "SHIPPING" section to Cookbook
 - Fix adding custom response headers when assets are already built #55
 - Fix always add newline to JavaScript assets to prevent issues with
   comments
 - Improved logging for in-memory assets
 - Improved error reporting when unable to build assets

0.63 2015-08-29T00:51:29+0200
 - Fix responding 404 when in-memory asset could not be found
 - Add support for custom response headers #55

0.62 2015-08-27T11:40:41-0400
 - Fix @import tracking #62

0.61 2015-08-23T13:34:34+0200
 - Add include_paths() to Scss preprocessor
 - Fix using SASS_PATH environment variable when calculating checksum #60
 - Deprecating asset->preprocessor() in favor of
   asset->preprocessors->add()

0.60 2015-08-20T17:21:54+0200
 - Fix detecting changed sass/scss files in sub directories, with leading
   underscore

0.59 2015-08-20T14:42:25+0200
 - Cannot look for packed files in "source_paths"
 - MOJO_ASSETPACK_DEBUG need to be set to "2" for more verbose debug

0.58 2015-08-09T14:28:04+0200
 - Change "source_paths" to return original reference and not a copy
 - Need to look for packed files in all directories (source_paths+public)

0.57 2015-08-09T11:34:21+0200
 - Add support for "source_paths" (EXPERIMENTAL) #58
 - Add support for fetching assets using a proxy

0.56 2015-08-05T10:44:15+0200
 - Add purge() method (EXPERIMENTAL)
 - Add EXPERIMENTAL support for wildcards in filenames #52

0.55 2015-05-25T12:58:04+0200
 - Will not add memory asset route if not needed #56
 - Make error visible regardless of page scroll position #57
   Contributor: Zoffix Znet

0.54 2015-04-23T17:37:01+0200
 - Fix saving unchanged assets on disk

0.53 2015-04-23T17:27:41+0200
 - Fix regenerating sprites:// assets

0.5201 2015-04-20T08:48:47+0200
 - Fix sprites.t
 - Fix skipping t/plugin-with-assets.t

0.52 2015-04-18T12:54:40+0200
 - Add support for generating image sprites and css
 - Add EXPERIMENTAL ::Handlers::Sprites, ::Handlers::Http and
   ::Handlers::Https
 - Add ::Asset::content()
 - Rename ::Asset::url() to path().
 - Remove ::Asset::add_chunk()

0.51 2015-04-16T08:15:50+0200
 - Can reload assets on server reload (EXPERIMENTAL)

0.50 2015-04-13T11:37:08+0200
 - Need to start with a fresh asset to avoid adding duplicate processed
   data to the same asset.

0.49 2015-04-05T09:54:27Z
 - Will not pack asset.ext.swp files

0.48 2015-04-05T09:19:01Z
 - Fix serving in memory assets with Content-Type
 - Fix serving in memory assets with Last-Modified

0.47 2015-04-04T13:53:32Z
 - Fix Mojo::Base::tap() does not support arguments before 5.57

0.4602 2015-04-02T18:44:01Z
 - Improved cpantesters

0.46 2015-04-01T15:09:35Z
 - Remove "fallback" attribute #44 (experimental)
 - Remove "process" method
 - Will prevent AssetPack from registering twice
 - Will not write assets to "mojo-assetpack-public" in TMPDIR #46
   (experimental)
 - Allow in-memory assets with out_dir(""), MOJO_ASSETPACK_DEBUG=1 or
   read-only static dirs. #46 (experimental)

0.45 2015-03-31T22:02:06Z
 - Can also fetch remote assets from local $app #30
 - Will calculate MD5 sum recursively for sass/scss #44
 - Add Cookbook

0.44 2015-03-23T13:00:45Z
 - Add ".min.ext" to minified asset filename
 - Change filename for assets with errors from "-with-error.ext" to
   ".err.ext"
 - Will look for existing assets even with MOJO_ASSETPACK_DEBUG=1
 - Remove errmsg() from Mojolicious::Plugin::AssetPack::Preprocessor
 - Remove detect() from Mojolicious::Plugin::AssetPack::Preprocessors

0.43 2015-03-20T11:27:22Z
 - Same CSS::Sass detection for Sass as for Scss preprocessor

0.42 2015-03-16T19:31:36Z
 - Fix "Unescaped left brace in regex is deprecated" warnings

0.41 2015-03-16T13:47:17Z
 - Will die on CSS::Sass errors

0.40 2015-03-16T11:04:47Z
 - Fix reading sass files from SASS_PATH, when using CSS::Sass

0.39 2015-03-06T17:06:19Z
 - Will default to CSS::Sass if installed
 - Reversed production/development logic
 - Fix spelling in documentation (berov)

0.3801 2015-03-02T23:58:21Z
 - Removed reference to "expand" #38

0.38 2015-03-02T23:55:36Z
 - Improved documentation.
 - Less logging

0.37 2015-02-04T16:59:36Z
 - Will use CSS::Sass if ENABLE_LIBSASS_BINDINGS=1 is set This is candiate
   to become the default in later releases

0.36 2015-01-30T12:08:51Z
 - Require JavaScript::Minifier::XS 0.11 which include many bugfixes, such
   as: JavaScript::Minifier::XS::minify(q|function(s){return /^\s*[\w-"']+
   *:/.test(s)}|);

0.35 2015-01-29T21:20:25Z
 - Include original error message when failing to fallback
 - Will die() instead of return $err on process()
 - Improved detection of minified JavaScript code #34

0.34 2015-01-23T12:51:25Z
 - Add preprocessor() method to AssetPack
 - Add support for assets from __DATA__

0.33 2015-01-06T20:00:42Z
 - Can fallback to existing assets in production mode

0.32 2014-12-18T12:23:58Z
 - Add logging of JavaScript code to console on error
 - Able to pass on attrs to script/link tag generator #33

0.31 2014-10-09T13:19:44Z
 - Fixed and wrote tests for external AssetPack plugins

0.30 2014-10-08T21:55:37Z
 - Processed assets can be other places than out_dir()

0.29 2014-10-08T20:53:32Z
 - Improved error message when unable to find external preprocessor
   (regression)

0.28 2014-10-07T23:58:45Z
 - Add support for %= asset "foo.js", { inline => 1 }
 - Will also generate asset files with md5 from single files
 - Remove expand()
 - Remove rebuild()

0.27 2014-10-07T00:28:39Z
 - Fix t/google-font.t

0.26 2014-10-07T00:16:27Z
 - Generate a different checksum when unable to process input files
 - Replaced "/Mojolicious/Plugin/AssetPack/could/not/compile/..." with an
   actual asset using Preprocessor::Fallback

0.25 2014-10-06T16:28:59Z
 - Preprocessors are added on the fly
 - Deprecated "no_autodetect"
 - Improved documentation

0.24 2014-09-28T20:44:00Z
 - Add preprocessor classes for every detected preprocessor
 - Add Preprocessors->can_process method to detect if preprocessors exists
 - Improved error message from sass preprocessor

0.23 2014-09-07T18:20:35Z
 - Add AssetPack->fetch() method #24
 - Can calculate checksum with included .sass and .scss files #25
 - Can load external assets with minify=0 #27
 - Support printing sass error to web page #26
 - Better error message when unable to find asset file
 - Change to using objects for processing files

0.22 2014-08-21T15:08:56Z
 - Made compass test more robust

0.21 2014-08-07T21:33:48Z
 - Add support for more debug output with MOJO_ASSETPACK_DEBUG=1
 - Add error message for missing "jsx" preprocessor
 - Will render missing text for all types which is not detected.
 - Remove map_type() from Mojolicious::Plugin::AssetPack::Preprocessors

0.20 2014-08-01T09:55:12Z
 - Catch exit code from external applications
 - Improved error messages

0.19 2014-07-27T20:26:45Z
 - Fix failing test for "compass"

0.18 2014-07-18T01:29:04Z
 - Will not continue if asset failed to download

0.17 2014-07-15T03:03:57Z
 - Fix loading empty javascript file

0.16 2014-07-07T22:39:30Z
 - Fix CPAN testers error
   http://www.cpantesters.org/cpan/report/caa7015a-050b-11e4-ae21-9a7d1ff27
   236

0.15 2014-07-05T11:28:42Z
 - Add JSX support.

0.14 2014-06-14T12:33:10Z
 - Add ::Preprocessors->map_type() method.
 - Add support for .sass files
 - Add support for sass+compass
 - Add support for custom base_url for minified assets

0.13 2014-06-09T16:11:57Z
 - Fix including online assets without extension
 - Fix Use of uninitialized value $_[3] in concatenation

0.12 2014-05-22T21:39:43Z
 - Allow asset moniker with same name as expanded packed filename.

0.11 2014-05-08T19:13:41Z
 - Add CoffeScript support. (Alexander Rymasheusky)
   https://github.com/jhthorsen/mojolicious-plugin-assetpack/pull/7
 - Add -I<path_to_dir> to sass command line (Per Edin)
   https://github.com/jhthorsen/mojolicious-plugin-assetpack/pull/5
 - Add support for MOJO_ASSETPACK_NO_CACHE=1 (Alexander Rymasheusky)
   https://github.com/jhthorsen/mojolicious-plugin-assetpack/pull/9

0.10 2014-05-08T19:09:00Z
 - See 0.11

0.09 2014-03-23T11:45:03Z
 - Remove option for cleaning up old asset files

0.08 2014-03-22T19:14:00Z
 - Fix finding compiled files by MD5 sum

0.07 2014-03-16T12:07:46Z
 - Add support for fetching assets from web
 - Improved support for finding a writeable out_dir

0.0601 2013-12-30T17:01:20Z
 - Fix bug when asset has the same moniker as one of the source files

0.06 2013-12-17T20:16:24Z
 - Will not die, but log with custom error message on missing preprocessor

0.0502 2013-11-27T09:21:33Z
 - Fix plan in t/expand.t when sass is missing

0.0501 2013-11-26T09:43:06Z
 - Cannot define assets when missing preprocessors

0.05 2013-11-24T18:20:11Z
 - Bundling JavaScript::Minifier::XS and CSS::Minifier::XS
 - Will calculate md5_sum from input files
 - Add support for getting assets for a moniker

0.0402 2013-11-12T21:17:34Z
 - Will select the latest processed file when preprocessor is missing

0.0401 2013-10-31T21:09:56Z
 - Fix cleanup of files without md5

0.04 2013-10-31T18:57:22Z
 - Add support for custom out_dir
 - Fix cannot lookup preprocessor based on moniker extension

0.03 2013-10-28T18:31:03Z
 - Use md5sum instead of timestamp in filenames

0.0201 2013-10-10T20:10:25Z
 - Fix need to change back to previous working dir

0.02 2013-09-24T09:17:43Z
 - Will only write asset files if the preprocessors exists

0.0102 2013-09-15T15:15:37Z
 - Fix AssetPack in embedded apps

0.0101 2013-09-15T14:26:29Z
 - Fix t/compress.t

0.01 2013-09-15T14:20:22Z
 - Add "asset" helper
 - Add support for chained preprocessors
 - Add default preprocessors for js, css, scss and less
 - Can expand from moniker to multiple script/link tags
 - Can compress multiple files to one moniker asset
